Pdf.railway <-
function(r,a) {
  y=rep(0,length(a))
  alfa=as.numeric(r['a'])
  b=as.numeric(r['b'])
  M=as.numeric(r['M'])
  sm=as.numeric(r['sm'])
  sp=as.numeric(r['sp'])
  hr=abs(1+.5*alfa/b)
  hl=abs(1-.5*alfa/b)
   
  f <- function(a,b,h,S){ # TODO replace by Cardano's formula
     b[1]=b[1]+a;
     p=polyroot(b); 
     iwant=(abs(Im(p))) < SMALL &  (S*Re(p)>=0) & (S*Re(p) <= h)
     if(sum(iwant) !=1) {
           iwant=c(TRUE,FALSE,FALSE); 
           warning(" cubic ambiguity")}
     return(S*Re(p[iwant]))}

  c1 <- alfa+b+hr*(alfa+2*b+2.*hr*b/3.)
  c2 <- -alfa+b-hl*(alfa-2*b-2*hl*b/3.)
  
  wanted    <- ( (a-M) <=c2 ) # 1st segment is linear
  slope     <- alfa-b*(2+hl)
  y[wanted] <- dnorm((a[wanted]-M-c2)/slope-hl-1,0,1)/slope 
  
  wanted <- ( (a-M >= c2 ) & (a-M <= -sm)) # second segment is cubic
  A <-  -b/3/hl # coeffts are for powers of (1+x)
  B <- -b
  C <- -alfa+2*b
  D <- alfa-b
  zz <- as.numeric(lapply(a[wanted]-M,f,c(D,C,B,A),hl,-1))
  y[wanted]=dnorm(-zz-1,0,1)/abs(3*A*(zz)^2 - 2*B*(zz)+C)

  wanted=( a >= M-sm) & (a<= M+sp) # third section is a parabola 
  up=(-alfa+sqrt(alfa^2+4*b*(a[wanted]-M)))/(2*b)
  y[wanted]=dnorm(up)/abs(alfa+2*b*up)
  
  wanted=( (a-M <= c1 ) & (a-M >= sp)) # fourth section is cubic
  A=b/3/hr
  B=-b
  C=-(alfa+2*b)
  D=-alfa-b
  zz <- as.numeric(lapply(a[wanted]-M,f,c(D,C,B,A),hr,1))
  y[wanted]=dnorm(zz+1,0,1)/abs(3*A*(zz)^2 + 2*B*(zz)+C)
  
  wanted=( (a-M) >= c1 )  #  fifth and final section is a straight line 
  slope=alfa+b*(2+hr)
  y[wanted]=dnorm((a[wanted]-c1-M)/slope+hr+1,0,1)/slope 
  
  y[is.na(y)]=0 # occasional glitch
  return(y)
}
