# solves a cubic using Cardono's formula
cardano <- function(a,b,c,d){
   p <- (3*a*c-b^2)/(3*a^2)
   q <- (2*b^3-9*a*b*c+27*a^2*d)/(27*a^3)
   disc2 <- q^2+4*p^3/27
   if(disc2>=0){ # one (real) solution
       disc <- sqrt(disc2)
       u3 <- (-q+disc)/2
       v3 <- (-q-disc)/2
       x  <- sign(u3)*abs(u3)^(1/3) + sign(v3)*abs(v3)^(1/3)
     } else { # three solutions
       R <- (sqrt((q^2-disc2))/2)**(1/3)
       phi <- atan2(sqrt(-disc2),-q)/3
       x <- R*c(2*cos(phi),-cos(phi)+sqrt(3)*sin(phi),-cos(phi)-sqrt(3)*sin(phi))
     }
     return(x-b/(3*a))
   }
