getPdfpars.edgeworth <-
function(p,model=0){
if(!is.na(p['V'])){ 
  V=as.numeric(p['V'])
  gamma=as.numeric(p['gamma'])
  mu=as.numeric(p['mu'])
  sigma=sqrt(V)
  guess=0
  for(i in 1:NTRY){
    old=guess
    guess=qnorm(.5+gamma*dnorm(guess)*(guess**2-1)/6/sigma^3)
    if(abs(old-guess)<SMALL) break
    }
  if(i>NTRY) readline("asymmetric error 3")
  M=sigma*guess+mu
  sp=mu-M+sqrt(V)
  sm=M-mu+sqrt(V)
  ans=c(p,M=M,sp=sp,sm=sm)
} else
{
M=as.numeric(p['M'])
sp=as.numeric(p['sp'])
sm=as.numeric(p['sm'])
mu=M+(sp-sm)/2
sigma=(sp+sm)/2
z=(M-mu)/sigma
ans=c(p,mu=mu,V=sigma^2,gamma=6*sigma^3*(pnorm(z)-.5)/((z^2-1)*dnorm(z)))
}
class(ans) <- 'edgeworth'
return(ans)
}
