getPdfpars.railway <-
function(p,model=0){
    getmoments <- function(alpha,beta){
       rr2pi <- 1./sqrt(2*pi)
       T1 <- exp(-.5)
       hr <- abs(1+.5*alpha/beta)
       hl <- abs(1- .5*alpha/beta)
  
       mu <- rep(0,5)
       V <- rep(0,5)
       gamma <- rep(0,5)

       Q1 <- pnorm(-1-hl,0,1)   #  first segment is a straight line 
       slope1 <-  alpha-beta*(2+hl)
       const1 <- -beta*(1+hl+hl^2/3.)
       I1 <- -exp(-(1+hl)^2/2)/sqrt(2*pi)
       I2 <- Q1-(1+hl)*I1
       I3 <- 2*I1+2*(hl+1)^2*I1
       mu[1] <- const1*Q1  +slope1*I1
       V[1] <- const1^2 * Q1 + 2*const1*slope1*I1+slope1^2*I2
       gamma[1] <- const1^3 * Q1 + 3*const1^2*slope1*I1+3*const1*slope1^2*I2+slope1^3*I3
       #print(paste(" segment 1 Q",Q1," mu ",mu[1]," V ",V[1]," gamma ",gamma[1]))
 
  Q2=pnorm(-1,0,1)-Q1
  T2=exp(-hl-hl^2/2)
  I1=-rr2pi*T1*(1-T2)
  I2=Q2-rr2pi*T1*((1+hl)*T2-1)
  I3=2*I1+rr2pi*T1*((1+hl)^2*T2 -1)
  I4=3*I2-rr2pi*T1*((1+hl)^3*T2 -1)
  I5=4*I3+rr2pi*T1*((1+hl)^4*T2 -1)
  I6=5*I4-rr2pi*T1*((1+hl)^5*T2 -1)
  I7=6*I5+rr2pi*T1*((1+hl)^6*T2 -1)
  I8=7*I6-rr2pi*T1*((1+hl)^7*T2 -1)
  I9=8*I7+rr2pi*T1*((1+hl)^8*T2 -1)
  C0=beta/(hl*3.0)
  C1=alpha+beta/hl
  C2=beta+beta/hl
  C3=beta/(3*hl)
  mu[2]=Q2*C0 + I1*C1 + I2*C2 + I3*C3
  V[2]=Q2*C0^2 +2*I1*C0*C1+I2*(2*C0*C2+C1^2)+I3*(2*C0*C3+2*C1*C2)+I4*(C2*C2+2*C1*C3)+2*I5*(C2*C3)+I6*C3^2
  gamma[2]=Q2*C0^3+ I1*3*C1*C0^2+ I2*3*(C0^2*C2 + C0*C1^2)+ I3*(C1^3 + 3*C0^2*C3 + 6*C0*C1*C2)+ I4*(3*C0*C2^2 + 6*C0*C1*C3 + 3*C1^2*C2)+
        I5*(3*C1*C2^2 + 6 * C0*C2*C3 + 3 *C1^2*C3)+ I6*(C2^3 + 3*C0*C3^2 + 6*C1*C2*C3)+ I7*3*(C2^2*C3 + C1*C3^2)+ I8*3*C2*C3^2+ I9*C3^3
  #print(paste(" segment 2 Q",Q2," mu ",mu[2]," V ",V[2]," gamma ",gamma[2]))
  
  Q3=pnorm(1,0,1)-(Q2 +Q1)   # segment 3 is a parabola
  I2=Q3-2*rr2pi*T1
  I4=3*I2-2*rr2pi*T1
  I6=5*I4-2*rr2pi*T1
  mu[3]= beta*I2
  V[3]=alpha^2*I2+beta^2*I4
  gamma[3]=3*alpha^2*beta*I4+beta^3*I6
  #print(paste(" segment 3 Q",Q3," mu ",mu[3]," V ",V[3]," gamma ",gamma[3]))

  Q4=pnorm(1+hr,0,1)-(Q3+Q2+Q1)
  C0=beta/(hr*3.0)
  C1=alpha-beta/hr
  C2=beta+beta/hr
  C3=-beta/(3*hr)
  T2=exp(-hr-hr^2/2)
  I1=rr2pi*T1*(1-T2)
  I2=Q4-rr2pi*T1*((1+hr)*T2-1)
  I3=2*I1-rr2pi*T1*((1+hr)^2*T2 -1)
  I4=3*I2-rr2pi*T1*((1+hr)^3*T2 -1)
  I5=4*I3-rr2pi*T1*((1+hr)^4*T2 -1)
  I6=5*I4-rr2pi*T1*((1+hr)^5*T2 -1)
  I7=6*I5-rr2pi*T1*((1+hr)^6*T2 -1)
  I8=7*I6-rr2pi*T1*((1+hr)^7*T2 -1)
  I9=8*I7-rr2pi*T1*((1+hr)^8*T2 -1)
  mu[4]=Q4*C0 + I1*C1 + I2*C2 + I3*C3
  V[4]=Q4*C0^2 +2*I1*C0*C1+I2*(2*C0*C2+C1^2)+I3*(2*C0*C3+2*C1*C2)+I4*(C2*C2+2*C1*C3)+2*I5*(C2*C3)+I6*C3^2
  gamma[4]=Q4*C0^3+
        I1*3*C1*C0^2+
        I2*3*(C0^2*C2 + C0*C1^2)+
        I3*(C1^3 + 3*C0^2*C3 + 6*C0*C1*C2)+
        I4*(3*C0*C2^2 + 6*C0*C1*C3 + 3*C1^2*C2)+
        I5*(3*C1*C2^2 + 6 * C0*C2*C3 + 3 *C1^2*C3)+ 
        I6*(C2^3 + 3*C0*C3^2 + 6*C1*C2*C3)+
        I7*3*(C2^2*C3 + C1*C3^2)+
        I8*3*C2*C3^2+
        I9*C3^3
  #print(paste(" segment 4 Q",Q4," mu ",mu[4]," V ",V[4]," gamma ",gamma[4]))

  Q5=1-(Q4+Q3+Q2+Q1)
  slope=alpha+beta*(2+hr)
  const =-beta*(1+hr+hr^2/3)
  I1=exp(-.5*(1+hr)^2)*rr2pi
  I2=Q5+(1+hr)*I1
  I3=2*I1+(1+hr)^2*I1
  mu[5]=const *Q5+slope*I1
  V[5]=const ^2 * Q5 + 2*const*slope*I1+slope^2*I2
  gamma[5]=const ^3 * Q5 + 3*const^2*slope*I1+3*const*slope^2*I2+slope^3*I3
  #print(paste(" segment 5 Q",Q5," mu ",mu[5]," V ",V[5]," gamma ",gamma[5]))
  mutot=sum(mu)
  Vtot <- sum(V)-(mutot)**2 
  gammatot=sum(gamma)-3*Vtot*mutot+mutot^3
       return(c(mu=mutot,V=Vtot, gamma=gammatot,a=alpha,b=beta))
  }
  g <- function(b,target){
     try=getmoments(.5,b)
     got=abs(try['gamma']/try['V']^1.5)
     return(got-target)
     }

if(!is.na(p['V'])){ mu=as.numeric(p['mu']); V <- as.numeric(p['V']); gamma=as.numeric(p['gamma']) # get from moments
  target=abs(gamma/V^1.5)
  trial=0
  got=0
  while(got<target){
     old=trial
     trial=0.01+1.1*trial
     try=getmoments(.5,trial)
     got=abs(try['gamma']/try['V']^1.5)
     }
  u=uniroot(g,c(old,trial),target)
  try=getmoments(.5,u$root)
  scalefactor=as.numeric(sqrt(V/try['V']))
  try['a'] = try['a']*scalefactor
  try['b'] = sign(gamma)*try['b']*scalefactor
  try['V'] = try['V']*scalefactor^2;
  try['gamma'] = sign(gamma)*try['gamma']*scalefactor^3;
  locfactor=as.numeric(mu-sign(gamma)*try['mu']*scalefactor)
  try['mu']=mu 
  ans <- c(M=locfactor, sp=as.numeric(try['a']+try['b']),sm=as.numeric(try['a']-try['b']),try)
  } else{ # get from quantiles
     M=as.numeric(p['M'])
     sp=as.numeric(p['sp'])
     sm=as.numeric(p['sm'])
     alpha=(sp+sm)/2
     beta=(sp-sm)/2
     ans=c(M=M,sp=sp,sm=sm,getmoments(alpha,beta))
     ans['mu'] <- ans['mu']+M
  }
   class(ans) <- 'railway'
   return(ans)
}
