\name{Pdf}
\alias{Pdf}
\title{ Probability Distribution Function }
\description{ Evaluate the Pdf according to a parameterised model }
\usage{ Pdf(r,a) }
\arguments{
  \item{r}{ named vector of parameters, as returned by \code{getPdfpars} }
  \item{a}{ numeric vector of values at which the Pdf is to be evaluated }
}
\value{ A vector of Pdf values, of the same length as \code{a} }
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }


\examples{
   r <- getPdfpars(c(M=10,sp=1.2,sm=0.9),"distorted")
   x <- seq(0,15,.1)
   plot(x,Pdf(r,x),type='l')
}
