\name{combinePdferrors}
\alias{combinePdferrors}
\title{ Combine errors from pdfs }
\description{ From a list of pfdfs, fin the combined error}
\usage{combinePdferrors(r) }
\arguments{
  \item{r}{ list of named vectors of parameters, as returned by \code{getPdfpars.} They must all be of the same model type }
}
\value{ A named vector of the same model type giving the parameters that give the same moments (mu,V, gamma) as the sum of the list.}
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }


\examples{
   v1=getPdfpars(c(M=1.1,sm=1.2,sp=1.3),"distorted")
   v2=getPdfpars(c(M=1.5,sm=1.3,sp=1.4),"distorted")
   v=combinePdferrors(list(v1,v2))
   print(v)
   print(paste("Chi squared is ",v['chisq']))
}
