\name{combinePdfresults}
\alias{combinePdfresults}
\title{ Combine the result from pdfs }
\description{ From a list of pfdfs, find the combined result}
\usage{ combinePdfresults(r) }
\arguments{
  \item{r}{ list of named vectors of parameters, as returned by \code{getPdfpars}. They must all be of the same model type }
}
\value{ A named vector of the same model type giving the 
 combined result, formed by the weighted average that minimises the variance.}
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }


\examples{
   v1=getPdfpars(c(M=1.1,sm=1.2,sp=1.3),"dimidiated")
   v2=getPdfpars(c(M=1.5,sm=1.3,sp=1.4),"dimidiated")
   v=combinePdfresults(list(v1,v2))
   print(v)
}
