\name{combinelnLerrors}
\alias{combinelnLerrors}
\title{ Combine errors from log likelihood curves }
\description{ From a list of log likelihood curves, find the peak and the Delta lnL=-1/2 errors}
\usage{ combinelnLerrors(r) }
\arguments{
  \item{r}{ list of named vectors of parameters, as returned by \code{getlnLpars}. They must all be of the same model type }
}
\value{ A named vector of the same model type giving the combined sp and sm,  the positive and negative errors. 
The value, which is meaningless, is returned as zero.
}
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }


\examples{
   v1=getlnLpars(c(val=1.1,sm=1.2,sp=1.3),"linearvariance")
   v2=getlnLpars(c(val=1.5,sm=1.3,sp=1.4),"linearvariance")
   v=combinelnLerrors(list(v1,v2))
   print(v)
}
