\name{combinelnLresults}
\alias{combinelnLresults}
\title{ Combine results from log likelihood curves }
\description{ From the sum of a list of log likelihood curves, find the peak and the Delta lnL=-1/2 errors}
\usage{ combinelnLresults(r) }
\arguments{
  \item{r}{ list of named vectors of parameters, as returned by \code{getlnLpars}. They must all be of the same model type }
}
\value{ A named vector of the same model type giving the peak position val  and sp and sm,  the positive and negative errors. The chi squared is also given
as the element named chisq}
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }


\examples{
   v1=getlnLpars(c(val=1.1,sm=1.2,sp=1.3),"linearvariance")
   v2=getlnLpars(c(val=1.5,sm=1.3,sp=1.4),"linearvariance")
   v=combinelnLresults(list(v1,v2))
   print(v)
   print(paste("Chi squared is ",v['chisq']))
}
