\name{getPdfpars}
\alias{getPdfpars}
\title{ Get parameters for asymmetric pdf }
\description{ Obtain the parameters for one of the near-Guassian models of lnL from the 3 quoted numbers: peak, sigma-plus and sigma-minus}
\usage{ getPdfpars(p,model) }
\arguments{
  \item{p}{ named vector giving either the moments (mu, V and sigma) or the quantile parameters  (M, sp and sm)}
  \item{model}{ string giving the model to be used)}
}
\value{ A named vector giving the parameters of the model, and also copies of the quantities in p and the alternative}
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }
\examples{
   r <- getPdfpars(c(M=10,sp=1.2,sm=0.9),"dimidiated")
   x=seq(0,5,.1)
   plot(x,Pdf(r,x),type='l')
}
