\name{getflipPdfpars}
\alias{getflipPdfpars}
\title{ Get parameters for "flipped" asymmetric pdf }
\description{ Obtain the parameters of an appropriate 
 pdf where the OPAT technique has given both errors with the same sign.}
\usage{ getflipPdfpars(p,model,direction) }
\arguments{
  \item{p}{ named vector giving the quantile parameters  (M, sp and sm).  Note that sp and sm are ALWAYS positive.}
  \item{model}{ string giving the model to be used. Only 'dimidiated' is supported at present)}
  \item{direction}{ +1 (default) if both errors are positive, -1 if both errors are negative}
}
\value{ A named vector giving the parameters of the model, assuming it has the standard form, like getPdfpars}
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }


\examples{
   r <- getflipPdfpars(c(M=10,sp=1.2,sm=0.9),"dimidiated",-1)
   x=seq(5,15,.1)
   plot(x,Pdf(r,x),type='l')
}
