\name{getlnLpars}
\alias{getlnLpars}
\title{ Get parameters for asymmetric Log Likelihood }
\description{ Obtain the parameters for one of the near-parabolic models of lnL from the 3 quoted numbers: peak, sigma-plus and sigma-minus}
\usage{ getlnLpars(p,model) }
\arguments{
  \item{p}{ named vector giving the central value (val), the positive error(sp) and the negative error (sm)} 
  \item{model}{ string giving the model to be used)}
}
\value{ A named vector giving the parameters of the model, and also copies of the quantities in p }
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }


\examples{
   r <- getlnLpars(c(val=10,sp=1.2,sm=0.9),"cubic")
   x=seq(0,5,.1)
   plot(x,lnL(r,x),type='l')
}
