\name{lnL}
\alias{lnL}
\title{ Log Likelihood }
\description{ Evaluate the log likelihood according to a parameterised model }
\usage{ lnL(r,a) }
\arguments{
  \item{r}{ named vector of parameters, as returned by \code{getlnLpars} }
  \item{a}{ numeric vector of values at which the likelihood is to be evaluated }
}
\value{ A vector of likelihood values, of the same length as \code{a} }
\references{ Barlow, Brazzale and Volobouev: Asymmetric Errors, arXiv ????, submitted to ????}
\author{ Roger Barlow }


\examples{
   p1 <- getlnLpars(c(val=10,sp=1.2,sm=0.9),"cubic")
   x=seq(0,5,.1)
   plot(x,lnL(p1,x),type='l')
}
